import axios from "axios";

class MyUploadAdapter {
  constructor(loader) {
    // The file loader instance to use during the upload.
    this.loader = loader;
  }

  // Starts the upload process.
  upload() {
    return this.loader.file.then(
      (file) =>
        new Promise((resolve, reject) => {
          console.log("MyUploadAdapter", file);
          const formData = new FormData();
          formData.append("image", file);
          formData.append("text", "asdas");
          axios
            .post("/api/page/uploadfile", formData, {
              headers: {
                "Content-Type": "multipart/formdata",
              },
            })
            .then((result) => {
              console.log("resultresultresult", result.data.url);
              if (result.status) {
                this.loader.uploaded = true;
                resolve({
                  default: result.data.url,
                });
              } else {
                reject(`Couldn't upload file: ${file.name}.`);
              }
            });
        })
    );
  }
}

// ...

export default function MyCustomUploadAdapterPlugin(editor) {
  editor.plugins.get("FileRepository").createUploadAdapter = (loader) => {
    // Configure the URL to the upload script in your back-end here!
    return new MyUploadAdapter(loader);
  };
}
