import { uploadUserPicture } from "@/middlewares/uploadMiddleware";
import User from "../../../model/user";
import dbConnect from "../../../utils/dbConnect";
import nc from "next-connect";
import Swal from "sweetalert2";

const bcrypt = require("bcrypt");

export const config = {
  api: {
    bodyParser: false,
  },
};

const handler = nc()
  .use(uploadUserPicture.single("fileName"))
  .post(async (req, res) => {
    try {
      let body = req.body;
      let file = req.file;
      console.log("file", file);
      console.log("bodyyyy", body);
      await dbConnect();
      let hashPassword = await bcrypt.hashSync(body.password, 10);
      console.log(body.password, hashPassword);
      // console.log("اللابابالاd");

      const existPhone = await User.find({
        phone: body.phone,
      }).countDocuments();

      if (existPhone > 0) {
        console.log("ffffffff");
        return res.status(402).json({
          message: "تلفن تکراری است",
          success: false,
        });
        return;
      }

      const newUser = new User({
        name: body.name,
        fileName: file.filename,
        username: body.username,
        university: body.university,
        dateOfProficiency: body.dateOfProficiency,
        nationalId: body.nationalId,
        password: hashPassword,
        phone: body.phone,
      });

      console.log("newUsertttttttttttt", newUser);
      newUser
        .save()
        .then((result) => {
          console.log("myresult", result);
          return res.status(200).json({
            message: "success",
            success: true,
          });
        })
        .catch((error) => {
          console.log(error);
          return res.status(401).json({
            message: "ERROR",
            success: false,
          });
        });
    } catch (err) {
      console.log(err);
      return res.status(401).json({
        message: "Error",
        success: false,
      });
    }
  });

export default handler;
