import axios from "axios";
import Link from "next/link";

import Image from "next/image";
import { useState, useEffect } from "react";
import AddIcon from "@mui/icons-material/Add";
import EditIcon from "@mui/icons-material/Edit";
import Dialog from "@mui/material/Dialog";
import DialogContent from "@mui/material/DialogContent";
import DialogTitle from "@mui/material/DialogTitle";
import { useLiTechController, setLoading } from "@/utils/context";
import HelpOutlineIcon from "@mui/icons-material/HelpOutline";
import CloseIcon from "@mui/icons-material/Close";
import IconButton from "@mui/material/IconButton";
import Members from "./manage";
import DeleteIcon from "@mui/icons-material/Delete";

import {
  successStoreMessage,
  errorMessage,
  catchMessage,
  deleteAlert,
  successDeleteMessage,
} from "../../utiliz/showMessage";
import config from "@/utils/config";
export default function EducationMembers(props) {
  const [controller, dispatch] = useLiTechController();

  const [open, setOpen] = useState(false);
  const [show, setShow] = useState(false);
  const handleShow = () => setShow(true);
  const handleOpen = (modeParam) => {
    if (modeParam) {
      setMode(modeParam);
    }
    setOpen(true);
  };
  const handleClose = () => {
    setEditId();
    setOpen(false);
    setShow(false);
  };
  const [members, setMembers] = useState();
  const [members2, setMembers2] = useState();
  const [mode, setMode] = useState();
  const [editId, setEditId] = useState();
  const [showDes, setShowDes] = useState("");
  const [addNewItem, setAddNewItem] = useState();
  const [addNewItem2, setAddNewItem2] = useState();

  const getMembers = async () => {
    try {
      await axios.get(`/api/member/1`).then((result) => {
        setMembers(result.data.data);
      });

      await axios.get(`/api/member/2`).then((result) => {
        setMembers2(result.data.data);
      });
    } catch (err) {
      console.log(err);
    }
  };

  const deleteMessage = async (id) => {
    console.log("idid", id);
    try {
      if (await deleteAlert()) {
        await axios
          .post(`/api/member/delete`, { id })

          .then((result) => {
            console.log("result", result);

            successDeleteMessage();

            getMembers();
          })
          .catch((err) => {
            console.log(err);
          });
      }
    } catch (err) {
      console.log(err);
    }
  };

  useEffect(() => {
    setAddNewItem(
      controller.authenticated && controller.userRole === "admin" && (
        <AddIcon
          style={{ cursor: "pointer", fontSize: 50 }}
          onClick={() => handleOpen(1)}
        />
      )
    );

    setAddNewItem2(
      controller.authenticated && controller.userRole === "admin" && (
        <AddIcon
          style={{ cursor: "pointer", fontSize: 50 }}
          onClick={() => handleOpen(2)}
        />
      )
    );

    getMembers();
  }, [controller.authenticated]);

  return (
    <div style={{ overflow: "hidden" }}>
      <section className="page__title-area pt-55   p-relative page__title-overlay sliderback">
        <div className="container">
          <div className="row">
            <div className="col-xxl-12">
              <div className="page__title-wrapper">
                <h3 className="page__title">اعضای هیات ممتحنه</h3>

                <nav aria-label="breadcrumb">
                  <ol className="breadcrumb">
                    <li className="breadcrumb-item">
                      <Link href="/"> خانه </Link>
                    </li>
                    <li className="breadcrumb-item active" aria-current="page">
                      اعضای هیات ممتحنه
                    </li>
                  </ol>
                </nav>
              </div>
            </div>
          </div>
        </div>
      </section>
      <section className="about__area  about-orange-color">
        <div className="row">
          <section className="category__area grey-bg-5 pt-110 pb-120">
            <div className="container">
              <div className="row justify-content-center">
                <div className="col-xxl-4 col-xl-6">
                  <div className="section__title-wrapper-7 mb-50 text-center">
                    <h2 className="section__title-7">
                      معرفی اعضای هیات ممتحنه در گذشته
                    </h2>
                    {addNewItem}
                  </div>
                </div>
              </div>
              <div className="row">
                {members?.map((item) => (
                  <div className=" col-md-6 col-12">
                    <HelpOutlineIcon
                      style={{
                        cursor: "pointer",
                        fontSize: 30,
                        display: "flex",
                        float: "left",
                        marginRight: -55,
                      }}
                      onClick={() => {
                        setShowDes(item.description);
                        handleShow();
                      }}
                    />
                    {controller.authenticated &&
                      controller.userRole === "admin" && (
                        <>
                          <EditIcon
                            style={{
                              cursor: "pointer",
                              fontSize: 25,
                              display: "flex",
                              float: "right",
                              marginLeft: -55,
                            }}
                            onClick={() => {
                              setEditId(item._id);
                              handleOpen();
                            }}
                          />

                          <DeleteIcon
                            style={{
                              cursor: "pointer",
                              fontSize: 25,
                              display: "flex",
                              float: "left",
                              marginRight: -55,
                              marginLeft: 30,
                            }}
                            className="button"
                            onClick={() => {
                              deleteMessage(item._id);
                            }}
                          />
                        </>
                      )}
                    <div className="category__item white-bg transition-3 mb-30 d-flex align-items-center">
                      <div className="category__icon mr-20">
                        <Image
                          src={`${config.uploadAddress}/upload/member/${item.fileName}`}
                          width={100}
                          height={100}
                          alt="هیات بورد فوق تخصصی بیماری های گوارش و کبد بزرگسالان"
                        />
                      </div>
                      <div
                        className="category__content"
                        style={{
                          display: "inline-block",
                          maxHeight: 30,
                          overflow: "hidden",
                        }}
                      >
                        <h3 className="category__title">{item.name}</h3>

                        <br />
                        <p>{item.education}</p>
                      </div>
                    </div>
                  </div>
                ))}
              </div>
            </div>
          </section>
        </div>
      </section>

      <section className="about__area  about-orange-color">
        <div className="row">
          <section className=" category__area grey-bg-5 pt-110 pb-120">
            <div className="container">
              <div className="row justify-content-center">
                <div className="col-xxl-4 col-xl-6">
                  <div className="section__title-wrapper-7 mb-50 text-center">
                    <h2 className="section__title-7">
                      معرفی اعضای هیات ممتحنه فعلی
                    </h2>
                    {addNewItem2}
                  </div>
                </div>
              </div>
              <div className="row">
                {members2?.map((item) => (
                  <div className=" col-md-6 col-12">
                    <HelpOutlineIcon
                      style={{
                        cursor: "pointer",
                        fontSize: 30,
                        display: "flex",
                        float: "left",
                        marginRight: -55,
                      }}
                      onClick={() => {
                        setShowDes(item.description);
                        handleShow();
                      }}
                    />
                    {controller.authenticated &&
                      controller.userRole === "admin" && (
                        <>
                          <EditIcon
                            style={{
                              cursor: "pointer",
                              fontSize: 25,
                              display: "flex",
                              float: "right",
                              marginLeft: -55,
                            }}
                            onClick={() => {
                              setEditId(item._id);
                              handleOpen();
                            }}
                          />
                          <DeleteIcon
                            style={{
                              cursor: "pointer",
                              fontSize: 25,
                              display: "flex",
                              float: "left",
                              marginRight: -55,
                              marginLeft: 30,
                            }}
                            className="button"
                            onClick={() => {
                              deleteMessage(item._id);
                            }}
                          />
                        </>
                      )}
                    <div className="category__item white-bg transition-3 mb-30 d-flex align-items-center">
                      <div className="category__icon mr-20">
                        <Image
                          src={`${config.uploadAddress}/upload/member/${item.fileName}`}
                          width={100}
                          height={100}
                          alt="هیات بورد فوق تخصصی بیماری های گوارش و کبد بزرگسالان"
                        />
                      </div>
                      <div
                        className="category__content"
                        style={{
                          display: "inline-block",
                          maxHeight: 30,
                          overflow: "hidden",
                        }}
                      >
                        <h3 className="category__title">{item.name}</h3>
                        <br />
                        <p>{item.education}</p>
                      </div>
                    </div>
                  </div>
                ))}
              </div>
            </div>
          </section>
        </div>
      </section>
      <Dialog
        open={open}
        onClose={handleClose}
        aria-labelledby="alert-dialog-title"
        aria-describedby="alert-dialog-description"
      >
        <DialogTitle id="alert-dialog-title">
          <h3 className="contact-form-title">
            {editId ? "ویرایش عضو اموزشی" : "ثبت عضو اموزشی"}
          </h3>
        </DialogTitle>

        <DialogContent>
          <Members
            id={editId}
            handleClose={handleClose}
            getMembers={getMembers}
            mode={mode}
            defaultRownumber={mode === 1 ? members?.length : members2?.length}
          />
        </DialogContent>
      </Dialog>

      <Dialog
        open={show}
        onClose={handleClose}
        aria-describedby="alert-dialog-member-description"
      >
        <IconButton
          edge="start"
          color="inherit"
          onClick={handleClose}
          aria-label="close"
        >
          <CloseIcon />
        </IconButton>

        <DialogContent style={{ minWidth: 500, minHeight: 350 }}>
          <div
            dangerouslySetInnerHTML={{
              __html: showDes?.replace(/\n/g, "<br/>"),
            }}
          />
        </DialogContent>
      </Dialog>
    </div>
  );
}
